> For the complete documentation index, see [llms.txt](https://developers.oxylabs.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.oxylabs.io/api-targets/es/e-commerce/kroger/search.md).

# Búsqueda

Extrae páginas de búsqueda de Kroger con filtros por rango de precios, marca y ubicación de la tienda. Recupera resultados de búsqueda organizados mediante API.

La `kroger_search` fuente de datos está diseñada para recuperar páginas de búsqueda de Kroger.

## Ejemplos de solicitud

En los ejemplos siguientes, realizamos una solicitud para recuperar una página de resultados de búsqueda para la consulta `running shoes`, filtre los resultados por la marca `adidas` y el rango de precios `100.00-200.00`, y especifique el ID de la tienda como `1100002`.

{% tabs %}
{% tab title="cURL" %}

```bash
curl 'https://realtime.oxylabs.io/v1/queries' \
--user 'USERNAME:PASSWORD' \
-H 'Content-Type: application/json' \
-d '{
        "source": "kroger_search",
        "query": "running shoes",
        "price_range": "100.00-200.00",
        "brand": "adidas",
        "store_id": "01100002"
    }'
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
from pprint import pprint

# Structure payload.
payload = {
    "source": "kroger_search",
    "query": "running shoes",
    "price_range": "100.00-200.00",
    "brand": "adidas",
    "store_id": "01100002",
}

# Get response.
response = requests.request(
    "POST",
    "https://realtime.oxylabs.io/v1/queries",
    auth=("USERNAME", "PASSWORD"),
    json=payload,
)

# Print prettified response to stdout.
pprint(response.json())
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const https = require("https");

const username = "USERNAME";
const password = "PASSWORD";
const body = {
    source: "kroger_search",
    query: "running shoes",
    price_range: "100.00-200.00",
    brand: "adidas",
    store_id: "01100002",
};

const options = {
    hostname: "realtime.oxylabs.io",
    path: "/v1/queries",
    method: "POST",
    headers: {
        "Content-Type": "application/json",
        Authorization:
            "Basic " + Buffer.from(`${username}:${password}`).toString("base64"),
    },
};

const request = https.request(options, (response) => {
    let data = "";

    response.on("data", (chunk) => {
        data += chunk;
    });

    response.on("end", () => {
        const responseData = JSON.parse(data);
        console.log(JSON.stringify(responseData, null, 2));
    });
});

request.on("error", (error) => {
    console.error("Error:", error);
});

request.write(JSON.stringify(body));
request.end();
```

{% endtab %}

{% tab title="HTTP" %}

```http
https://realtime.oxylabs.io/v1/queries?source=kroger_search&query=running+shoes&price_range=100.00-200.00&brand=adidas&store_id=01100002&access_token=12345abcde
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php

$params = array(
    "source" => "kroger_search",
    "query" => "running shoes",
    "price_range" => "100.00-200.00",
    "brand" => "adidas",
    "store_id" => "01100002",
);

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://realtime.oxylabs.io/v1/queries");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_USERPWD, "USERNAME" . ":" . "PASSWORD");

$headers = array();
$headers[] = "Content-Type: application/json";
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
echo $result;

if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close($ch);
?>
```

{% endtab %}

{% tab title="Golang" %}

```go
package main

import (
	"bytes"
	"encoding/json"
	"fmt"
	"io/ioutil"
	"net/http"
)

func main() {
	const Username = "USERNAME"
	const Password = "PASSWORD"

	payload := map[string]interface{}{
		"source":     "kroger_search",
		"query": "running shoes",
		"price_range": "100.00-200.00",
		"brand":      "adidas",
		"store_id":   "01100002",
	}

	jsonValue, _ := json.Marshal(payload)

	client := &http.Client{}
	request, _ := http.NewRequest("POST",
		"https://realtime.oxylabs.io/v1/queries",
		bytes.NewBuffer(jsonValue),
	)

	request.SetBasicAuth(Username, Password)
	response, _ := client.Do(request)

	responseText, _ := ioutil.ReadAll(response.Body)
	fmt.Println(string(responseText))
}
```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;

namespace OxyApi
{
    class Program
    {
        static async Task Main()
        {
            const string Username = "USERNAME";
            const string Password = "PASSWORD";

            var parameters = new {
                source = "kroger_search",
                query = "running shoes",
                price_range = "100.00-200.00",
                brand = "adidas",
                store_id = "01100002"
            };

            var client = new HttpClient();

            Uri baseUri = new Uri("https://realtime.oxylabs.io");
            client.BaseAddress = baseUri;

            var requestMessage = new HttpRequestMessage(HttpMethod.Post, "/v1/queries");
            requestMessage.Content = JsonContent.Create(parameters);

            var authenticationString = $"{Username}:{Password}";
            var base64EncodedAuthenticationString = Convert.ToBase64String(System.Text.ASCIIEncoding.UTF8.GetBytes(authenticationString));
            requestMessage.Headers.Add("Authorization", "Basic " + base64EncodedAuthenticationString);

            var response = await client.SendAsync(requestMessage);
            var contents = await response.Content.ReadAsStringAsync();

            Console.WriteLine(contents);
        }
    }
}
```

{% endtab %}

{% tab title="Java" %}

```java
package org.example;

import okhttp3.*;
import org.json.JSONObject;

import java.util.concurrent.TimeUnit;

public class Main implements Runnable {
    private static final String AUTHORIZATION_HEADER = "Authorization";
    public static final String USERNAME = "USERNAME";
    public static final String PASSWORD = "PASSWORD";

    public void run() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("source", "kroger_search");
        jsonObject.put("query", "running shoes");
        jsonObject.put("price_range", "100.00-200.00");
        jsonObject.put("brand", "adidas");
        jsonObject.put("store_id", "01100002");

        Authenticator authenticator = (route, response) -> {
            String credential = Credentials.basic(USERNAME, PASSWORD);

            return response
                    .request()
                    .newBuilder()
                    .header(AUTHORIZATION_HEADER, credential)
                    .build();
        };

        var client = new OkHttpClient.Builder()
                .authenticator(authenticator)
                .readTimeout(180, TimeUnit.SECONDS)
                .build();

        var mediaType = MediaType.parse("application/json; charset=utf-8");
        var body = RequestBody.create(jsonObject.toString(), mediaType);
        var request = new Request.Builder()
                .url("https://realtime.oxylabs.io/v1/queries")
                .post(body)
                .build();

        try (var response = client.newCall(request).execute()) {
            if (response.body() != null) {
                try (var responseBody = response.body()) {
                    System.out.println(responseBody.string());
                }
            }
        } catch (Exception exception) {
            System.out.println("Error: " + exception.getMessage());
        }

        System.exit(0);
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
```

{% endtab %}

{% tab title="JSON" %}

```json
{
    "source": "kroger_search", 
    "query": "running shoes",
    "price_range": "100.00-200.00",
    "brand": "adidas",
    "store_id": "01100002"
}
```

{% endtab %}
{% endtabs %}

Usamos la integración síncrona [**Realtime**](/products/es/web-scraper-api/integration-methods/realtime.md) método de integración en nuestros ejemplos. Si desea usar [**Proxy Endpoint**](/products/es/web-scraper-api/integration-methods/proxy-endpoint.md) o asíncrona [**Push-Pull**](/products/es/web-scraper-api/integration-methods/push-pull.md) integración, consulte la [**métodos de integración**](/products/es/web-scraper-api/integration-methods.md) sección.

## Valores de parámetros de solicitud

### General

Opciones básicas de configuración y personalización para extraer páginas de búsqueda de Kroger.

<table><thead><tr><th width="222">Parámetro</th><th width="322.3333333333333">Descripción</th><th>Valor predeterminado</th></tr></thead><tbody><tr><td><mark style="background-color:green;"><strong>source</strong></mark></td><td>Establece el scraper.</td><td><code>kroger_search</code></td></tr><tr><td><mark style="background-color:green;"><strong>query</strong></mark></td><td>La palabra clave o frase para buscar productos.</td><td>-</td></tr><tr><td><code>render</code></td><td>Habilita el renderizado de JavaScript cuando se establece en <code>html</code>. <a href="/products/es/web-scraper-api/features/js-rendering-and-browser-control.md#javascript-rendering"><strong>Más información</strong></a><strong>.</strong></td><td>-</td></tr><tr><td><code>callback_url</code></td><td>URL a su endpoint de callback. <a href="/products/es/web-scraper-api/integration-methods/push-pull.md"><strong>Más información</strong></a></td><td>-</td></tr><tr><td><code>user_agent_type</code></td><td>Tipo de dispositivo y navegador. La lista completa se puede encontrar <a href="/products/es/web-scraper-api/features/http-context-and-job-management/user-agent-type.md"><strong>aquí</strong></a>.</td><td><code>desktop</code></td></tr></tbody></table>

\- parámetro obligatorio

### Localización

Personalice los resultados según las ubicaciones de las tiendas, las áreas de entrega y los métodos de cumplimiento preferidos.

<table><thead><tr><th width="210">Parámetro</th><th width="172.33333333333331">Descripción</th><th width="153">Valor predeterminado</th><th>Dependencias</th></tr></thead><tbody><tr><td><code>store_id</code></td><td>Especifique una tienda. Consulte los valores disponibles <a href="https://files.gitbook.com/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FzrXw45naRpCZ0Ku9AjY1%2Fuploads%2FAsihGe7hi5yfauUl2JIQ%2Fkroger_stores.csv?alt=media&#x26;token=40fcd869-1845-47c5-bf76-96e74cabf685"><strong>aquí</strong></a>. El ID debe empezar con '0'.</td><td>-</td><td>Requerido cuando <code>fulfillment_type</code> se establece en <code>pickup</code> o <code>in_store</code>.</td></tr><tr><td><code>delivery_zip</code></td><td>Especifique el código postal de la ubicación de entrega.</td><td>-</td><td>Requerido cuando <code>fulfillment_type</code> se establece en <code>delivery</code>.</td></tr><tr><td><code>fulfillment_type</code></td><td>Especifique el método de cumplimiento del pedido. Valores disponibles: <code>pickup</code>, <code>delivery</code>, <code>in_store</code>.</td><td><code>pickup</code> (si solo <code>store_id</code> se proporciona)</td><td>Requiere <code>store_id</code> para <code>pickup</code> y <code>in_store</code>, o <code>delivery_zip</code> para <code>delivery</code>.</td></tr></tbody></table>

**Dependencias explicadas:**

* `pickup` y `in_store` los valores usan el `store_id` parámetro para determinar la tienda correcta.
* `delivery` usa el `delivery_zip` parámetro para especificar la ubicación de entrega.
* Si solo `store_id` se proporciona, y `fulfillment_type` no se especifica, el tipo predeterminado es `pickup`.

{% hint style="warning" %}
Si la `fulfillment_type` y `store_id`/`delivery_zip` combinación no es válida (no compatible con Kroger), la página extraída devolverá un estado 400.
{% endhint %}

### Filtrado

Opciones para filtrar y refinar los resultados de búsqueda según varios criterios.

<table><thead><tr><th width="222">Parámetro</th><th width="325.3333333333333">Descripción</th><th>Valor predeterminado</th></tr></thead><tbody><tr><td><code>price_range</code></td><td>Define el rango de precios deseado, con el formato <code>min_price-max_price</code> con dos decimales, separados por un guion (p. ej., <code>10.00-20.00</code>).</td><td>-</td></tr><tr><td><code>brand</code></td><td>Filtra los resultados de búsqueda para incluir productos de una marca específica.</td><td>-</td></tr></tbody></table>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developers.oxylabs.io/api-targets/es/e-commerce/kroger/search.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
